Index: EcnlProtoTool/trunk/ntshell/src/netcmd.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/netcmd.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/netcmd.c	(revision 442)
@@ -40,5 +40,4 @@
 #include <t_stdlib.h>
 #include <sil.h>
-#include <string.h>
 #include "syssvc/serial.h"
 #include "syssvc/syslog.h"
@@ -59,6 +58,4 @@
 #include <netapp/resolver.h>
 #include "core/ntlibc.h"
-#include "util/ntstdio.h"
-#include <stdio.h>
 #include "ntp_cli.h"
 #include "kernel_cfg.h"
@@ -71,5 +68,4 @@
 extern void ping6(T_IN6_ADDR *addr, uint_t tmo, uint_t len);
 extern void ping4(T_IN4_ADDR *addr, uint_t tmo, uint_t len);
-extern ntstdio_t *ntstdio;
 
 /*
@@ -255,9 +251,9 @@
 
 	if (apip == '1')
-		ntlibc_strcpy(line, i6rlp_pmtu_str1);
+		strcpy(line, i6rlp_pmtu_str1);
 	else if (apip == '2')
-		ntlibc_strcpy(line, i6rlp_pmtu_str2);
+		strcpy(line, i6rlp_pmtu_str2);
 	else if (apip == '3')
-		ntlibc_strcpy(line, i6rlp_pmtu_str3);
+		strcpy(line, i6rlp_pmtu_str3);
 
 #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
@@ -280,5 +276,5 @@
 
 	if ((line = lookup_ipaddr(&addr, line, apip)) == NULL) {
-		ntstdio_printf(ntstdio, "[PING] unknown host.\n");
+		printf("[PING] unknown host.\n");
 		return 0;
 	}
@@ -299,18 +295,18 @@
 #if defined(SUPPORT_INET4)
 	if (apip == API_PROTO_IPV6) {
-		ntstdio_printf(ntstdio, "[PING6] size: %d, tmo: %d, host: %s\n", size, tmo, ipv62str(NULL, &addr));
+		printf("[PING6] size: %d, tmo: %d, host: %s\n", size, tmo, ipv62str(NULL, &addr));
 		ping6(&addr, (uint_t)tmo, (uint_t)size);
 	}
 	else {
 		addr4 = ntohl(addr.s6_addr32[3]);
-		ntstdio_printf(ntstdio, "[PING4] size: %d, tmo: %d, host: %s\n", size, tmo, ip2str(NULL, &addr4));
+		printf("[PING4] size: %d, tmo: %d, host: %s\n", size, tmo, ip2str(NULL, &addr4));
 		ping4(&addr4, (uint_t)tmo, (uint_t)size);
 	}
 #else /* of #if defined(SUPPORT_INET4) */
-	ntstdio_printf(ntstdio, "[PING6] size: %d, tmo: %d, host: %s\n", size, tmo, ipv62str(NULL, &addr));
+	printf("[PING6] size: %d, tmo: %d, host: %s\n", size, tmo, ipv62str(NULL, &addr));
 	ping6(&addr, (uint_t)tmo, (uint_t)size);
 #endif	/* of #if defined(SUPPORT_INET4) */
 #else	/* of #if defined(SUPPORT_INET6) */
-	ntstdio_printf(ntstdio, "[PING4] size: %d, tmo: %d, host: %s\n", size, tmo, ip2str(NULL, &addr));
+	printf("[PING4] size: %d, tmo: %d, host: %s\n", size, tmo, ip2str(NULL, &addr));
 	ping4(&addr, (uint_t)tmo, (uint_t)size);
 #endif	/* of #if defined(SUPPORT_INET6) */
@@ -331,13 +327,13 @@
 		pos = str_ipv4addr(temp, sizeof(temp), &svaddr, 0);
 		temp[pos] = '\0';
-		ntstdio_printf(ntstdio, "DHCPv4 server: %s,\n", temp);
-		ntstdio_printf(ntstdio, "  Renew:       %u:%02u:%02u,\n",
+		printf("DHCPv4 server: %s,\n", temp);
+		printf("  Renew:       %u:%02u:%02u,\n",
 			renew / 3600, (renew / 60) % 60, renew % 60);
-		ntstdio_printf(ntstdio, "  Rebind:      %u:%02u:%02u, Expire:   %u:%02u:%02u.\n",
+		printf("  Rebind:      %u:%02u:%02u, Expire:   %u:%02u:%02u.\n",
 			rebind / 3600, (rebind / 60) % 60, rebind % 60,
 			expire / 3600, (expire / 60) % 60, expire % 60);
 	}
 	else if (ret == E_OBJ)
-		ntstdio_printf(ntstdio, "DHCPv4 server: not available.\n");
+		printf("DHCPv4 server: not available.\n");
 }
 
@@ -349,11 +345,11 @@
 		return 0;
 
-	if (ntlibc_strcmp(argv[1], "rel") == 0) {
+	if (strcmp(argv[1], "rel") == 0) {
 		ret = dhcp4c_rel_info();
-		ntstdio_printf(ntstdio, "dhcp4c_rel_info %d\n", ret);
-	}
-	else if (ntlibc_strcmp(argv[1], "renew") == 0) {
+		printf("dhcp4c_rel_info %d\n", ret);
+	}
+	else if (strcmp(argv[1], "renew") == 0) {
 		ret = dhcp4c_renew_info();
-		ntstdio_printf(ntstdio, "dhcp4c_renew_info %d\n", ret);
+		printf("dhcp4c_renew_info %d\n", ret);
 	}
 	else {
@@ -383,8 +379,8 @@
 		else {
 			for (c = 1; c <= *ptr; c++)
-				ntstdio_printf(ntstdio, "%c", *(ptr + c));
+				printf("%c", *(ptr + c));
 			ptr += *ptr + 1;
 			if (*ptr)
-				ntstdio_printf(ntstdio, ".");
+				printf(".");
 		}
 	}
@@ -406,16 +402,16 @@
 		return error;
 
-	ntstdio_printf(ntstdio, "    mname:   ");
+	printf("    mname:   ");
 	rn_offset = s_show_dns_domain_name(msg, offset);
 	putchar('\n');
-	ntstdio_printf(ntstdio, "    rname:   ");
+	printf("    rname:   ");
 	s_show_dns_domain_name(msg, rn_offset);
 	putchar('\n');
 
-	ntstdio_printf(ntstdio, "    serial:  %d\n", soa.serial);
-	ntstdio_printf(ntstdio, "    refresh: %d\n", soa.refresh);
-	ntstdio_printf(ntstdio, "    retry:   %d\n", soa.retry);
-	ntstdio_printf(ntstdio, "    expirel: %d\n", soa.expire);
-	ntstdio_printf(ntstdio, "    minimum: %d\n", soa.minimum);
+	printf("    serial:  %d\n", soa.serial);
+	printf("    refresh: %d\n", soa.refresh);
+	printf("    retry:   %d\n", soa.retry);
+	printf("    expirel: %d\n", soa.expire);
+	printf("    minimum: %d\n", soa.minimum);
 
 	return E_OK;
@@ -433,5 +429,5 @@
 	int		scount;
 
-	ntstdio_printf(ntstdio, "question   section: %d\n", rslv->dns_hdr.qdcount);
+	printf("question   section: %d\n", rslv->dns_hdr.qdcount);
 	offset = rslv->qd_offset;
 	for (scount = 1; scount <= rslv->dns_hdr.qdcount; scount++) {
@@ -439,7 +435,7 @@
 			return error;
 
-		ntstdio_printf(ntstdio, "%2d: ", scount);
+		printf("%2d: ", scount);
 		s_show_dns_domain_name(msg, offset);
-		ntstdio_printf(ntstdio, "\n    type: %-4s, class: %2s\n", dns_strtype(qd.type), dns_strclass(qd.class));
+		printf("\n    type: %-4s, class: %2s\n", dns_strtype(qd.type), dns_strclass(qd.class));
 		offset = error;
 	}
@@ -463,12 +459,12 @@
 	int pos;
 
-	ntstdio_printf(ntstdio, "%10s section: %d\n", title, scount);
+	printf("%10s section: %d\n", title, scount);
 	for (count = 1; count <= scount; count++) {
 		if ((error = dns_analyze_rr(&rr, offset, msg, length)) < 0)
 			return error;
 
-		ntstdio_printf(ntstdio, "%2d: ", count);
+		printf("%2d: ", count);
 		s_show_dns_domain_name(msg, offset);
-		ntstdio_printf(ntstdio, "\n    type: %-4s, class: %2s, TTL: %2d, len: %3d, offset: 0x%02x\n",
+		printf("\n    type: %-4s, class: %2s, TTL: %2d, len: %3d, offset: 0x%02x\n",
 			dns_strtype(rr.type), dns_strclass(rr.class), rr.ttl, rr.rdlength, rr.rdata_offset);
 
@@ -479,13 +475,13 @@
 			pos = str_ipv4addr(temp, sizeof(temp), &in4_addr, 0);
 			temp[pos] = '\0';
-			ntstdio_printf(ntstdio, "    IPv4 addr: %s\n", temp);
+			printf("    IPv4 addr: %s\n", temp);
 			break;
 		case DNS_TYPE_NS:
-			ntstdio_printf(ntstdio, "    host: ");
+			printf("    host: ");
 			s_show_dns_domain_name(msg, rr.rdata_offset);
 			putchar('\n');
 			break;
 		case DNS_TYPE_CNAME:
-			ntstdio_printf(ntstdio, "    host: ");
+			printf("    host: ");
 			s_show_dns_domain_name(msg, rr.rdata_offset);
 			putchar('\n');
@@ -495,5 +491,5 @@
 			break;
 		case DNS_TYPE_PTR:
-			ntstdio_printf(ntstdio, "     PTR: ");
+			printf("     PTR: ");
 			s_show_dns_domain_name(msg, rr.rdata_offset);
 			putchar('\n');
@@ -503,13 +499,13 @@
 			pos = str_ipv6addr(temp, sizeof(temp), &in6_addr, 0);
 			temp[pos] = '\0';
-			ntstdio_printf(ntstdio, "    IPv6 addr: %s\n", temp);
+			printf("    IPv6 addr: %s\n", temp);
 			break;
 		default:
-			ntstdio_printf(ntstdio, "    data: ");
+			printf("    data: ");
 			col = 32;
 			for (dcount = 0; dcount < rr.rdlength; dcount++) {
-				ntstdio_printf(ntstdio, "%02x", *(msg + rr.rdata_offset + dcount));
+				printf("%02x", *(msg + rr.rdata_offset + dcount));
 				if (--col == 0) {
-					ntstdio_printf(ntstdio, "\n          ");
+					printf("\n          ");
 					col = 32;
 				}
@@ -539,9 +535,9 @@
 #if defined(SUPPORT_INET6)
 
-	ntstdio_printf(ntstdio, "domain name:     %s\n", dns_in6_get_dname());
+	printf("domain name:     %s\n", dns_in6_get_dname());
 
 #else	/* of #if defined(SUPPORT_INET6) */
 
-	ntstdio_printf(ntstdio, "domain name:     %s\n", dns_in4_get_dname());
+	printf("domain name:     %s\n", dns_in4_get_dname());
 
 #endif	/* of #if defined(SUPPORT_INET6) */
@@ -549,11 +545,11 @@
 #if defined(SUPPORT_INET6)
 	dns_in6_get_addr(&in6_addr);
-	ntstdio_printf(ntstdio, "IPv6 DNS server: ");
+	printf("IPv6 DNS server: ");
 	if (IN6_IS_ADDR_UNSPECIFIED(&in6_addr))
-		ntstdio_printf(ntstdio, "not available.\n");
+		printf("not available.\n");
 	else {
 		pos = str_ipv6addr(temp, sizeof(temp), &in6_addr, 0);
 		temp[pos] = '\0';
-		ntstdio_printf(ntstdio, "%s.\n", temp);
+		printf("%s.\n", temp);
 	}
 #endif	/* of #if defined(SUPPORT_INET6) */
@@ -561,11 +557,11 @@
 #if defined(SUPPORT_INET4)
 	dns_in4_get_addr(&in4_addr);
-	ntstdio_printf(ntstdio, "IPv4 DNS server: ");
+	printf("IPv4 DNS server: ");
 	if (in4_addr == IPV4_ADDRANY)
-		ntstdio_printf(ntstdio, "not available.\n");
+		printf("not available.\n");
 	else {
 		pos = str_ipv4addr(temp, sizeof(temp), &in4_addr, 0);
 		temp[pos] = '\0';
-		ntstdio_printf(ntstdio, "%s.\n", temp);
+		printf("%s.\n", temp);
 	}
 #endif	/* of #if defined(SUPPORT_INET4) */
@@ -596,5 +592,5 @@
 	uint8_t 	*msg;
 
-	if (ntlibc_strcmp(line, "info") == 0) {
+	if (strcmp(line, "info") == 0) {
 		dns_info();
 		return 0;
@@ -604,5 +600,5 @@
 	line = skip_blanks(resolv_options(&flags, line, DEFAULT_API_PROTO));
 	if ((flags & (DNS_LUP_FLAGS_PROTO_IPV6 | DNS_LUP_FLAGS_PROTO_IPV4)) == 0) {
-		ntstdio_printf(ntstdio, "DNS server not available.\n");
+		printf("DNS server not available.\n");
 		return 0;
 	}
@@ -620,47 +616,47 @@
 
 	if ((error = tget_mpf(MPF_RSLV_SRBUF, (void*)&msg, TMO_FEVR)) != E_OK) {
-		ntstdio_printf(ntstdio, "get buffer error: %s.\n", itron_strerror(error));
+		printf("get buffer error: %s.\n", itron_strerror(error));
 		return 0;
 	}
 
 	if ((length = dns_lookup_host(flags | DNS_LUP_FLAGS_MSG, line, msg, DNS_UDP_MSG_LENGTH, &rslv)) < 0) {
-		//ntstdio_printf(ntstdio, "error: %s.\n", itron_strerror(length));
+		//printf("error: %s.\n", itron_strerror(length));
 		goto err_ret;
 	}
 
 	dly_tsk(1 * 1000);
-	ntstdio_printf(ntstdio, "DNS header: flags: ");
+	printf("DNS header: flags: ");
 	if (rslv.dns_hdr.code & (DNS_QR_RESPONSE | DNS_AUTHORITATIVE |
 		DNS_TRUN_CATION | DNS_RECURSION_DESIRED | DNS_RECURSION_AVAILABLE)) {
-		ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_QR_RESPONSE) ? "QR," : "");
-		ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_AUTHORITATIVE) ? "AA," : "");
-		ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_TRUN_CATION) ? "TC," : "");
-		ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_RECURSION_DESIRED) ? "RD," : "");
-		ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_RECURSION_AVAILABLE) ? "RA," : "");
-		ntstdio_printf(ntstdio, " ");
-	}
-	ntstdio_printf(ntstdio, "opcode: ");
-	ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_OPCODE_REVERSE) ? "RV" : "FW");
-	ntstdio_printf(ntstdio, (rslv.dns_hdr.code & DNS_OPCODE_STATUS) ? ",ST" : "");
-	ntstdio_printf(ntstdio, ", rcode: %s.\n",
+		printf((rslv.dns_hdr.code & DNS_QR_RESPONSE) ? "QR," : "");
+		printf((rslv.dns_hdr.code & DNS_AUTHORITATIVE) ? "AA," : "");
+		printf((rslv.dns_hdr.code & DNS_TRUN_CATION) ? "TC," : "");
+		printf((rslv.dns_hdr.code & DNS_RECURSION_DESIRED) ? "RD," : "");
+		printf((rslv.dns_hdr.code & DNS_RECURSION_AVAILABLE) ? "RA," : "");
+		printf(" ");
+	}
+	printf("opcode: ");
+	printf((rslv.dns_hdr.code & DNS_OPCODE_REVERSE) ? "RV" : "FW");
+	printf((rslv.dns_hdr.code & DNS_OPCODE_STATUS) ? ",ST" : "");
+	printf(", rcode: %s.\n",
 		(rslv.dns_hdr.code & DNS_RCODE_MASK) > DNS_RCODE_REFUSED
 		? "6" : rcode_str[rslv.dns_hdr.code & DNS_RCODE_MASK]);
 
 	if ((offset = show_dns_qdsection(msg, length, &rslv)) < 0) {
-		ntstdio_printf(ntstdio, "msg error: %s.\n", itron_strerror(offset));
+		printf("msg error: %s.\n", itron_strerror(offset));
 	}
 	if ((offset = show_dns_section(msg, length, rslv.dns_hdr.ancount, rslv.an_offset, "answer")) < 0) {
-		ntstdio_printf(ntstdio, "msg error: %s.\n", itron_strerror(offset));
+		printf("msg error: %s.\n", itron_strerror(offset));
 	}
 	if ((offset = show_dns_section(msg, length, rslv.dns_hdr.nscount, rslv.ns_offset, "authority")) < 0) {
-		ntstdio_printf(ntstdio, "msg error: %s.\n", itron_strerror(offset));
+		printf("msg error: %s.\n", itron_strerror(offset));
 	}
 	if ((offset = show_dns_section(msg, length, rslv.dns_hdr.arcount, rslv.ar_offset, "additional")) < 0) {
-		ntstdio_printf(ntstdio, "msg error: %s.\n", itron_strerror(offset));
+		printf("msg error: %s.\n", itron_strerror(offset));
 	}
 
 err_ret:
 	if ((error = rel_mpf(MPF_RSLV_SRBUF, msg)) != E_OK)
-		ntstdio_printf(ntstdio, "release buffer error: %s.\n", itron_strerror(error));
+		printf("release buffer error: %s.\n", itron_strerror(error));
 	return 0;
 }
Index: EcnlProtoTool/trunk/ntshell/src/newlib_stub.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/newlib_stub.c	(revision 442)
+++ EcnlProtoTool/trunk/ntshell/src/newlib_stub.c	(revision 442)
@@ -0,0 +1,115 @@
+/*
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2020 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+
+#include <stdint.h>
+#include <sys/stat.h>
+#include <errno.h>
+#include <kernel.h>
+#include "kernel_cfg.h"
+
+#undef errno
+extern int errno;
+
+long __syscall_ret(unsigned long r)
+{
+	if (r > -4096UL) {
+		errno = -r;
+		return -1;
+	}
+	return r;
+}
+
+int _kill(int pid, int sig)
+{
+	return 0;
+}
+
+int _getpid(int n)
+{
+	return 1;
+}
+
+int _close(int fd)
+{
+	return __syscall_ret(shell_close(fd));
+}
+
+long _read(int fd, void *buf, long count)
+{
+	return __syscall_ret(shell_read(fd, buf, count));
+}
+
+long _write(int fd, const void *buf, long count)
+{
+	return __syscall_ret(shell_write(fd, buf, count));
+}
+
+off_t _lseek(int fd, off_t offset, int whence)
+{
+	off_t result;
+	long ret = shell_llseek(fd, offset, &result, whence);
+	return __syscall_ret(ret) ? -1 : result;
+}
+
+int _fstat(int fd, struct stat *st)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return __syscall_ret(-EBADF);
+
+	memset(st, 0, sizeof(*st));
+	st->st_mode = S_IFCHR;
+	//st->st_blksize = 1024;
+	return 0;
+}
+
+// musl-1.1.18\arch\generic\bits\ioctl.h
+#define TIOCGWINSZ	0x5413
+
+struct winsize {
+	unsigned short ws_row;
+	unsigned short ws_col;
+	unsigned short ws_xpixel;
+	unsigned short ws_ypixel;
+};
+
+int _isatty(int fd)
+{
+	struct winsize wsz;
+	long ret = shell_ioctl(fd, TIOCGWINSZ, &wsz);
+	return __syscall_ret(ret);
+}
Index: EcnlProtoTool/trunk/ntshell/src/ntp_cli.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/ntp_cli.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/ntp_cli.c	(revision 442)
@@ -271,5 +271,5 @@
 
 	nc->buf[0] = '\0';
-#ifdef __NEED_struct_timespec
+#ifdef _TIME_H_
 	if (ctime_r(&tp.tv_sec, nc->buf) != NULL)
 #else
Index: EcnlProtoTool/trunk/ntshell/src/pipe_stub.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/pipe_stub.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/pipe_stub.c	(revision 442)
@@ -36,5 +36,4 @@
  */
 #include "shellif.h"
-#include <stdint.h>
 #include <kernel.h>
 #include <t_syslog.h>
@@ -46,6 +45,4 @@
 #include "fdtable.h"
 #include "kernel_cfg.h"
-#include <string.h>
-#include "util/ntstdio.h"
 #include "hal/serial_api.h"
 
Index: EcnlProtoTool/trunk/ntshell/src/shellif.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/shellif.c	(revision 442)
+++ EcnlProtoTool/trunk/ntshell/src/shellif.c	(revision 442)
@@ -0,0 +1,324 @@
+/*
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2020 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+
+#include "shellif.h"
+#include "target_syssvc.h"
+#include "kernel_cfg.h"
+
+extern int shellcmd_exit_code;
+extern jmp_buf shellcmd_exit;
+
+void shell_abort()
+{
+	shellcmd_exit_code = -1;
+	longjmp(shellcmd_exit, 1);
+}
+
+void shell_exit(int exitcd)
+{
+	shellcmd_exit_code = exitcd;
+	longjmp(shellcmd_exit, 1);
+}
+
+void shell_exit_group(int exitcd)
+{
+	shellcmd_exit_code = exitcd;
+	longjmp(shellcmd_exit, 1);
+}
+
+const struct utsname host_name = {
+	"TOPPERS/ASP3",
+	TARGET_NAME,
+	"3.5.0",
+	"3.5.0",
+	TARGET_NAME,
+	"toppers.jp"
+};
+
+int shell_uname(struct utsname *uts)
+{
+	memcpy(uts, &host_name, sizeof(host_name));
+	return 0;
+}
+
+int shell_clock_getres(clockid_t clk_id, struct timespec *res)
+{
+	if ((clk_id != CLOCK_REALTIME) && (clk_id != CLOCK_MONOTONIC))
+		return -EINVAL;
+
+	memset(&res->tv_sec, 0xFF, sizeof(res->tv_sec));
+	res->tv_nsec = 0;
+
+	return 0;
+}
+
+int shell_clock_gettime(clockid_t clk_id, struct timespec *tp)
+{
+	SYSTIM now = 0;
+
+	if ((clk_id != CLOCK_REALTIME) && (clk_id != CLOCK_MONOTONIC))
+		return -EINVAL;
+
+	get_tim(&now);
+	tp->tv_sec = now / 1000000;
+	tp->tv_nsec = (now % 1000000) * 1000;
+
+	return 0;
+}
+
+int shell_clock_settime(clockid_t clk_id, const struct timespec *tp)
+{
+	if ((clk_id != CLOCK_REALTIME) && (clk_id != CLOCK_MONOTONIC))
+		return -EINVAL;
+
+	SYSTIM time;
+	ER ret;
+
+	time = (tp->tv_sec * 1000000ll) + (tp->tv_nsec / 1000ll);
+
+	ret = set_tim(time);
+	if (ret != E_OK) {
+		return -EPERM;
+	}
+
+	return 0;
+}
+
+sigset_t g_sigmask;
+
+int shell_sigprocmask(int how, const sigset_t *restrict set, sigset_t *restrict old)
+{
+	if (old != NULL)
+		memcpy(old, &g_sigmask, sizeof(sigset_t));
+
+	switch (how) {
+	case SIG_BLOCK:
+		for (int i = 0; i < sizeof(g_sigmask.__bits) / sizeof(g_sigmask.__bits[0]); i++) {
+			g_sigmask.__bits[i] |= set->__bits[i];
+		}
+		break;
+	case SIG_UNBLOCK:
+		for (int i = 0; i < sizeof(g_sigmask.__bits) / sizeof(g_sigmask.__bits[0]); i++) {
+			g_sigmask.__bits[i] &= ~set->__bits[i];
+		}
+		break;
+	case SIG_SETMASK:
+		memcpy(&g_sigmask, set, sizeof(sigset_t));
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+// musl-1.1.18\src\internal\ksigaction.h
+struct k_sigaction {
+	void(*handler)(int);
+	unsigned long flags;
+	void(*restorer)(void);
+	unsigned mask[2];
+};
+
+struct k_sigaction sigtable[7];
+
+int shell_sigaction(int sig, const struct k_sigaction *restrict sa,
+	struct k_sigaction *restrict old, size_t size)
+{
+	struct k_sigaction *sat;
+
+	switch(sig){
+	case SIGALRM:
+		sat = &sigtable[0];
+		break;
+	case SIGFPE:
+		sat = &sigtable[1];
+		break;
+	case SIGILL:
+		sat = &sigtable[2];
+		break;
+	case SIGSEGV:
+		sat = &sigtable[3];
+		break;
+	case SIGBUS:
+		sat = &sigtable[4];
+		break;
+	case SIGABRT:
+		sat = &sigtable[5];
+		break;
+	case SIGPIPE:
+		sat = &sigtable[6];
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	if (old != NULL)
+		memcpy(old, sat, offsetof(struct k_sigaction, mask) + size);
+
+	memcpy(sat, sa, offsetof(struct k_sigaction, mask) + size);
+
+	return 0;
+}
+
+int shell_madvise(void *a, size_t b, int c)
+{
+	return 0;
+}
+
+int shell_gettid()
+{
+	ID tskid;
+	ER ret;
+
+	ret = get_tid(&tskid);
+	if (ret != E_OK)
+		return -1;
+
+	return tskid;
+}
+
+int shell_tkill(int tid, int sig)
+{
+	if ((tid == SHELLCMD_TASK) && (sig == SIGABRT)) {
+		shell_abort();
+	}
+
+	no_implement("tkill");
+	return -1;
+}
+
+int shell_kill(int pid, int sig)
+{
+	DebugBreak();
+	return -1;
+}
+
+int shell_gettimeofday(struct timeval *tv, void *tzvp)
+{
+	SYSTIM time;
+	if (!tv) return 0;
+	get_tim(&time);
+	tv->tv_sec = time / 1000000;
+	tv->tv_usec = time - (tv->tv_sec * 1000000);
+	return 0;
+}
+
+int shell_nanosleep(const struct timespec *req, struct timespec *rem)
+{
+	ER ret;
+	TMO tmo;
+	SYSTIM prev, now, diff;
+
+	if ((req == NULL) || (req->tv_nsec < 0) || (req->tv_nsec >= 1000000000))
+		return -EINVAL;
+
+	get_tim(&prev);
+
+	tmo = req->tv_sec * 1000000 + req->tv_nsec / 1000;
+	ret = tslp_tsk(tmo);
+	if (ret == E_OK) {
+		if (rem != NULL) {
+			get_tim(&now);
+			diff = now - prev;
+			rem->tv_sec = diff / 1000000ll;
+			rem->tv_nsec = (diff - (rem->tv_sec * 1000000ll)) * 1000ll;
+		}
+		return 0;
+	}
+	else if (ret == E_TMOUT) {
+		if (rem != NULL) {
+			rem->tv_sec = 0;
+			rem->tv_nsec = 0;
+		}
+		return 0;
+	}
+
+	return -EFAULT;
+}
+
+ssize_t shell_getrandom(void *buf, size_t buflen, unsigned int flags)
+{
+	SYSTIM now;
+	int32_t i;
+	int *output = (int *)buf;
+	size_t sz = buflen / 4;
+
+	get_tim(&now);
+	srand(now);
+
+	for (i = 0; i < sz; i++)
+		output[i] = rand();
+
+	for (i = 4 * sz; i < buflen; i++)
+		((char *)buf)[i] = rand();
+
+	return buflen;
+}
+
+extern uint32_t  __CmdBase;
+extern uint32_t  __CmdLimit;
+
+void *shell_brk(void *addr)
+{
+	if (addr == 0) {
+		return (void *)((intptr_t)&__CmdBase + 0x40000);
+	}
+	if ((addr >= (intptr_t)&__CmdBase + 0x40000) && (addr < &__CmdLimit)) {
+		return addr;
+	}
+	return (void *)-1;
+}
+
+void *shell_mmap2(void *start, size_t length, int prot, int flags, int fd, off_t pgoffset)
+{
+	if (fd != -1)
+		return -EINVAL;
+
+	if ((length >= 0) && (length <= (intptr_t)&__CmdLimit - ((intptr_t)&__CmdBase + 0x40000))) {
+		return &__CmdBase + 0x40000;
+	}
+	return (void *)-1;
+}
+
+int shell_mprotect(void *addr, size_t len, int prot)
+{
+	//if ((addr >= (intptr_t)&__CmdBase + 0x40000) && ((intptr_t)addr + len < &__CmdLimit)) {
+		return 0;
+	//}
+	//return -1;
+}
Index: EcnlProtoTool/trunk/ntshell/src/shellif.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/shellif.h	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/shellif.h	(revision 442)
@@ -88,4 +88,9 @@
 #define NCCS 32
 
+#include "../musl-1.1.18/include/stdint.h"
+#include "../musl-1.1.18/include/strings.h"
+#define _STRINGS_H_ // newlibã®strings.hã®includeãææ­¢
+#include "../musl-1.1.18/include/string.h"
+#define _STRING_H_ // newlibã®string.hã®includeãææ­¢
 #include "../musl-1.1.18/include/bits/fcntl.h"
 #include "../musl-1.1.18/include/bits/termios.h"
@@ -93,6 +98,8 @@
 #include "../musl-1.1.18/include/sys/select.h"
 #include "../musl-1.1.18/include/time.h"
+#define _TIME_H_ // newlibã®time.hã®includeãææ­¢
 #include "../musl-1.1.18/include/signal.h"
 #include "../musl-1.1.18/include/stdio.h"
+#define	_STDIO_H_ // newlibã®stdio.hã®includeãææ­¢
 #include "../musl-1.1.18/include/sys/utsname.h"
 #include "../musl-1.1.18/include/dirent.h"
@@ -104,4 +111,5 @@
 #include <stddef.h>
 #include <stdarg.h>
+#include <setjmp.h>
 
 #define DebugBreak()	asm("bkpt #0")
Index: EcnlProtoTool/trunk/ntshell/src/socket_stub.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/socket_stub.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/socket_stub.c	(revision 442)
@@ -39,5 +39,4 @@
 #include <t_syslog.h>
 #include <t_stdlib.h>
-#include <string.h>
 #include <sil.h>
 #include "syssvc/syslog.h"
Index: EcnlProtoTool/trunk/ntshell/src/stdio_stub.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/stdio_stub.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/stdio_stub.c	(revision 442)
@@ -36,5 +36,4 @@
  */
 #include "shellif.h"
-#include <stdint.h>
 #include <kernel.h>
 #include <t_syslog.h>
@@ -46,6 +45,4 @@
 #include "fdtable.h"
 #include "kernel_cfg.h"
-#include <string.h>
-#include <errno.h>
 #include "util/ntstdio.h"
 #include "hal/serial_api.h"
@@ -58,5 +55,6 @@
 #endif
 
-int shell_errno;
+#undef errno
+extern int errno;
 
 extern bool_t sio_isr_snd(ID siopid);
@@ -105,5 +103,4 @@
 
 stdio_sio_t stdio_sio;
-ntstdio_t *ntstdio = &stdio_sio.ntstdio;
 
 void sys_init(intptr_t exinf)
@@ -573,10 +570,10 @@
 	struct SHELL_FILE *fp = fd_to_fp(fd);
 	if ((fp == NULL) || (fp->type != &IO_TYPE_SIO)) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
 
-	shell_errno = sio_close(fp);
-	if (shell_errno != 0)
+	errno = sio_close(fp);
+	if (errno != 0)
 		return 1;
 	return 0;
@@ -587,5 +584,5 @@
 	struct SHELL_FILE *fp = fd_to_fp(fd);
 	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_SIO))) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
@@ -604,5 +601,5 @@
 	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDOUT) && (fp->type != &IO_TYPE_STDERR)
 		&& (fp->type != &IO_TYPE_SIO))) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
@@ -621,10 +618,10 @@
 	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
 		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
 
-	shell_errno = sio_tcsetattr(fp, act, tio);
-	if (shell_errno != 0)
+	errno = sio_tcsetattr(fp, act, tio);
+	if (errno != 0)
 		return 1;
 	return 0;
@@ -636,10 +633,10 @@
 	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
 		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
 
-	shell_errno = sio_tcgetattr(fp, tio);
-	if (shell_errno != 0)
+	errno = sio_tcgetattr(fp, tio);
+	if (errno != 0)
 		return 1;
 	return 0;
@@ -651,5 +648,5 @@
 	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
 		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
-		shell_errno = EBADF;
+		errno = EBADF;
 		return -1;
 	}
@@ -660,6 +657,6 @@
 	va_end(ap);
 
-	shell_errno = sio_ioctl(fp, cmd, arg);
-	if (shell_errno != 0)
+	errno = sio_ioctl(fp, cmd, arg);
+	if (errno != 0)
 		return 1;
 	return 0;
Index: EcnlProtoTool/trunk/ntshell/src/syscall.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/syscall.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/syscall.c	(revision 442)
@@ -102,4 +102,5 @@
 	case SYS__llseek:
 		ret = shell_llseek(r->a, (((off_t)r->b) << 32) + (off_t)r->c, (off_t *)r->d, r->e);
+		break;
 	case SYS__newselect:
 		ret = shell_select(r->a, (fd_set *)r->b, (fd_set *)r->c, (fd_set *)r->d, (struct timeval *)r->e);
Index: EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl	(revision 442)
@@ -49,5 +49,5 @@
  *  NTShell に関する定義
  */
-import_C("termios.h");
+import_C("mbed_retarget.h");
 
 /*
Index: EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShellMain.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShellMain.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShellMain.c	(revision 442)
@@ -46,11 +46,9 @@
 #include <t_syslog.h>
 #include <errno.h> 
-#include <termios.h>
-#include <unistd.h>
-#include <fcntl.h>
 #include "tSIOPortNTShellMain_tecsgen.h"
 #include "syssvc/siofd.h"
  
-extern int shell_errno;
+#undef errno
+extern int errno;
 
 /*
@@ -130,5 +128,5 @@
 		}
 		else {
-			assert(n < 0 && shell_errno == EAGAIN);
+			assert(n < 0 && errno == EAGAIN);
 			VAR_snd_flag = true;
 			VAR_snd_buf = c;
@@ -159,5 +157,5 @@
 	}
 	else {
-		assert(n < 0 && shell_errno == EAGAIN);
+		assert(n < 0 && errno == EAGAIN);
 		return(-1);
 	}
Index: EcnlProtoTool/trunk/ntshell/webserver/base64.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/base64.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/webserver/base64.c	(revision 442)
@@ -86,5 +86,5 @@
     unsigned char *pdst;
     int i, j = 0, k = 0;
-    size_t srcsiz = ntlibc_strlen((const char *)src);
+    size_t srcsiz = strlen((const char *)src);
 
     if ((srcsiz % 4) != 0) {
Index: EcnlProtoTool/trunk/ntshell/webserver/http_parser.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/webserver/http_parser.c	(revision 441)
+++ EcnlProtoTool/trunk/ntshell/webserver/http_parser.c	(revision 442)
@@ -2372,5 +2372,5 @@
   if (u->field_set & (1 << UF_PORT)) {
     /* Don't bother with endp; we've already validated the string */
-    unsigned long v = ntlibc_strtoul(buf + u->field_data[UF_PORT].off, NULL, 10);
+    unsigned long v = strtoul(buf + u->field_data[UF_PORT].off, NULL, 10);
 
     /* Ports have a max value of 2^16 */
